src/config/urls.py
from django.contrib import admin
from django.urls import path, include

from students.views import IndexView, PageNotFoundView

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("admin/", admin.site.urls),
    path("groups/", include("groups.urls")),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("", IndexView.as_view(), name="index"),
    path("oauth/", include("social_django.urls", namespace="social")),
]


handler404 = PageNotFoundView.as_view()

src/students/urls.py
from django.urls import path

from students.views import (
    GetStudentsView,
    CreateStudentView,
    UpdateStudentView,
    DeleteStudentView,
    SearchHistoryView,
    UserLoginView,
    UserLogoutView,
    UserRegistrationView,
    UserPasswordResetView,
    UserPasswordResetDoneView,
    UserPasswordResetConfirmView,
    UserPasswordResetCompleteView,
    ActivateUserView,
    UserProfile,
)

app_name = "students"

urlpatterns = [
    path("", GetStudentsView.as_view(), name="get_students"),
    path("create/", CreateStudentView.as_view(), name="create_student"),
    path("update/<uuid:pk>/", UpdateStudentView.as_view(), name="update_student"),
    path("delete/<uuid:pk>/", DeleteStudentView.as_view(), name="delete_student"),
    path("history/", SearchHistoryView.as_view(), name="search_history"),
    path("user-login/", UserLoginView.as_view(), name="user_login"),
    path("user-logout/", UserLogoutView.as_view(), name="user_logout"),
    path("user-registration/", UserRegistrationView.as_view(), name="user_registration"),
    path("password_reset/", UserPasswordResetView.as_view(), name="password_reset"),
    path("password_reset/done/", UserPasswordResetDoneView.as_view(), name="password_reset_done", ),
    path("reset/<uidb64>/<token>/", UserPasswordResetConfirmView.as_view(), name="password_reset_confirm", ),
    path("reset/done/", UserPasswordResetCompleteView.as_view(), name="password_reset_complete", ),
    path("activate/<str:uuid64>/<str:token>/", ActivateUserView.as_view(), name="activate"),
    path("profile/<int:pk>/", UserProfile.as_view(), name="profile"),
]

src/teachers/urls.py
from django.urls import path

from teachers.views import (
    CreateTeacherView,
    GetTeachersView,
    UpdateTeacherView,
    DeleteTeacherView,
)

app_name = "teachers"

urlpatterns = [
    path("", GetTeachersView.as_view(), name="get_teachers"),
    path("create/", CreateTeacherView.as_view(), name="create_teacher"),
    path("update/<uuid:pk>/", UpdateTeacherView.as_view(), name="update_teacher"),
    path("delete/<uuid:pk>/", DeleteTeacherView.as_view(), name="delete_teacher"),
]

src/templates/index.html
{% load static %}

<!doctype html>
<html lang="en" class="h-100">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="Mark Otto, Jacob Thornton, and Bootstrap contributors">
    <meta name="generator" content="Hugo 0.88.1">
    <title>Courses | educational project</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
          rel="stylesheet" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
          crossorigin="anonymous">

    <style>
        .bd-placeholder-img {
            font-size: 1.125rem;
            text-anchor: middle;
            -webkit-user-select: none;
            -moz-user-select: none;
            user-select: none;
        }

        @media (min-width: 768px) {
            .bd-placeholder-img-lg {
                font-size: 3.5rem;
            }
        }

    </style>

    <!-- Custom styles for this template -->
    <link href={% static 'css/cover.css' %} rel="stylesheet" type="text/css">
</head>

<body class="d-flex h-100 text-center text-white bg-dark">

<div class="cover-container d-flex w-100 h-100 p-3 mx-auto flex-column">
    <header class="mb-auto">
        <div>
            <h3 class="float-md-start mb-0">LMS</h3>

            <nav class="nav nav-masthead justify-content-center float-md-end">

                <a class="nav-link" aria-current="page" href=" {% url 'index' %} ">Home</a>

                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button"
                       data-bs-toggle="dropdown" aria-expanded="false">
                        Students
                    </a>
                    <ul class="dropdown-menu bg-dark" aria-labelledby="navbarDropdown">
                        <li><a class="nav-link" href=" {% url 'students:get_students' %} ">All students</a></li>
                        <li><a class="nav-link" href=" {% url 'students:create_student' %} ">Create student</a></li>
                    </ul>
                </li>

                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button"
                       data-bs-toggle="dropdown" aria-expanded="false">
                        Teachers
                    </a>
                    <ul class="dropdown-menu bg-dark" aria-labelledby="navbarDropdown">
                        <li><a class="nav-link" href=" {% url 'teachers:get_teachers' %} ">All teachers</a></li>
                        <li><a class="nav-link" href=" {% url 'teachers:create_teacher' %} ">Create teacher</a></li>
                    </ul>
                </li>

                <a class="nav-link" href=" {% url 'students:search_history' %} ">History</a>

                {% if user.is_authenticated %}
                    <div class="dropdown text-end nav-link">
                        <a href="#" class="d-block link-secondary text-decoration-none dropdown-toggle"
                           id="dropdownUser1"
                           data-bs-toggle="dropdown" aria-expanded="false">
                            {% if user.photo %}
                                <img src="{{ user.photo }}" alt="mdo" width="32" height="32"
                                     class="rounded-circle">
                            {% else %}
                                <img src="https://github.com/mdo.png" alt="mdo" width="32" height="32"
                                     class="rounded-circle">
                            {% endif %}
                        </a>
                        <ul class="dropdown-menu text-small" aria-labelledby="dropdownUser1">
                            <li><a class="dropdown-item disabled">Hello, {{ user.first_name|title }}</a></li>
                            {% if user.is_staff %}
                                <li><a class="dropdown-item" href="{% url "admin:index" %}">Admin panel</a></li>
                            {% endif %}
                            <li><a class="dropdown-item" href="#">Settings</a></li>
                            <li><a class="dropdown-item" href="{% url "students:profile" user.profile.id %}">Profile</a>
                            </li>
                            <li>
                                <hr class="dropdown-divider">
                            </li>
                            <li><a class="dropdown-item" href="{% url "students:user_logout" %}">Logout</a></li>
                        </ul>
                    </div>
                {% else %}
                    <div class="dropdown text-end nav-link">
                        <a href="#" class="d-block link-secondary text-decoration-none dropdown-toggle"
                           id="dropdownUser1"
                           data-bs-toggle="dropdown" aria-expanded="false">
                            <img src={% static 'img/avatars/avatar.png' %} alt="mdo" width="32" height="32"
                                 class="rounded-circle">
                        </a>
                        <ul class="dropdown-menu text-small" aria-labelledby="dropdownUser1">
                            <li><a class="dropdown-item" href="{% url "students:user_registration" %}">Registration</a>
                            </li>
                            <li>
                                <hr class="dropdown-divider">
                            </li>
                            <li>
                                <div class="dropdown-item disabled">Login</div>
                                <a class="dropdown-item" href="{% url "students:user_login" %}">
                                    <img src={% static 'img/social/telephone.png' %} width="24" height="24"> Phone
                                    number</a></li>
                            <li><a class="dropdown-item" href="{% url "social:begin" "google-oauth2" %}">
                                <img src={% static 'img/social/google.png' %} width="24" height="24"> Google</a></li>
                            <li><a class="dropdown-item" href="{% url "social:begin" "linkedin-oauth2" %}">
                                <img src={% static 'img/social/linkedin.png' %} width="24" height="24"> Linkedin</a>
                            </li>
                            <li><a class="dropdown-item" href="{% url "social:begin" "github" %}">
                                <img src={% static 'img/social/github.png' %} width="24" height="24"> Github</a></li>
                            <li>
                                <hr class="dropdown-divider">
                            </li>
                            <li><a class="dropdown-item" href="{% url "students:password_reset" %}">Reset password</a>
                            </li>
                        </ul>

                    </div>
                {% endif %}

                <form class="d-flex">
                    <input class="form-control me-2 search-field" type="search" name="search_text" placeholder="Search"
                           aria-label="Search">
                </form>
            </nav>
        </div>
    </header>

    <main>
        {% block content %}
            <!-- Carousel -->
            <div id="carouselExampleDark" class="carousel slide" data-bs-ride="carousel">
                <div class="carousel-indicators">
                    <button type="button" data-bs-target="#carouselExampleDark" data-bs-slide-to="0" class="active"
                            aria-current="true" aria-label="Slide 1"></button>
                    <button type="button" data-bs-target="#carouselExampleDark" data-bs-slide-to="1"
                            aria-label="Slide 2"></button>
                    <button type="button" data-bs-target="#carouselExampleDark" data-bs-slide-to="2"
                            aria-label="Slide 3"></button>
                </div>
                <div class="carousel-inner">
                    <div class="carousel-item active" data-bs-interval="10000">
                        <img src="{% static 'img/image_1.jpg' %}" class="d-block w-100" alt="...">
                        <div class="carousel-caption d-none d-md-block">
                            <h1>Python course</h1>
                            <p>Master the basics of data analysis in Python. Expand your skillset by learning scientific
                                computing with NumPy.</p>
                        </div>
                    </div>
                    <div class="carousel-item" data-bs-interval="2000">
                        <img src="{% static 'img/image_2.jpg' %}" class="d-block w-100" alt="...">
                        <div class="carousel-caption d-none d-md-block">
                            <h1>HTML, CSS course</h1>
                            <p>HTML is the foundation of all web pages. It defines the structure of a page, while CSS
                                defines its style. HTML and CSS are the beginning of everything you need to know to make
                                your first web page! Learn both and start creating amazing websites.</p>
                        </div>
                    </div>
                    <div class="carousel-item">
                        <img src="{% static 'img/image_3.jpg' %}" class="d-block w-100" alt="...">
                        <div class="carousel-caption d-none d-md-block">
                            <h1>Java course</h1>
                            <p>In this Programming with Mosh YouTube course, you will learn about strings, arrays,
                                conditionals, loops and more. You will also build a mortgage calculator.</p>
                        </div>
                    </div>
                </div>
                <button class="carousel-control-prev" type="button" data-bs-target="#carouselExampleDark"
                        data-bs-slide="prev">
                    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                    <span class="visually-hidden">Previous</span>
                </button>
                <button class="carousel-control-next" type="button" data-bs-target="#carouselExampleDark"
                        data-bs-slide="next">
                    <span class="carousel-control-next-icon" aria-hidden="true"></span>
                    <span class="visually-hidden">Next</span>
                </button>
            </div>
            <!-- End of carousel -->
        {% endblock %}
    </main>

    <footer class="mt-auto text-white-50">
        <div>Project made by <a href="https://gitlab.com/julia.izotowa/lms" class="text-white">Julia Izotowa</a></div>
    </footer>
</div>

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p"
        crossorigin="anonymous"></script>

</body>
</html>

src/templates/profile.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}

    <style>

        body {
            margin-top: 20px;
            color: #1a202c;
            text-align: left;
            background-color: #e2e8f0;
        }

        .main-body {
            padding: 15px;
        }

        .card {
            box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .1), 0 1px 2px 0 rgba(0, 0, 0, .06);
        }

        .card {
            position: relative;
            display: flex;
            flex-direction: column;
            min-width: 0;
            word-wrap: break-word;
            background-color: #fff;
            background-clip: border-box;
            border: 0 solid rgba(0, 0, 0, .125);
            border-radius: .25rem;
        }

        .card-body {
            flex: 1 1 auto;
            min-height: 1px;
            padding: 1rem;
        }

        .gutters-sm {
            margin-right: -8px;
            margin-left: -8px;
        }

        .gutters-sm > .col, .gutters-sm > [class*=col-] {
            padding-right: 8px;
            padding-left: 8px;
        }

        .mb-3 {
            margin-bottom: 1rem !important;
        }

        .col-md-8 {
            border-top: 0px !important;
        }
    </style>

    <div class="container">
        <div class="main-body">

            <div class="row gutters-sm table table-dark table-striped">
                <div class="col-md-4 mb-3">
                    <div class="card">
                        <div class="card-body">
                            <div class="d-flex flex-column align-items-center text-center">
                                {% if user.profile.photo %}
                                    <img src="{{ user.profile.photo.url }}" alt=""
                                         class="rounded-circle" width="150">
                                {% else %}
                                    <img src="https://bootdey.com/img/Content/avatar/avatar7.png" alt=""
                                         class="rounded-circle" width="150">
                                {% endif %}
                                <div class="mt-3">
                                    <h4>{{ user.first_name }} {{ user.last_name }}</h4>
                                    <p class="text-muted font-size-sm">{{ user.profile.bio }}</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-8">
                    <div class="card mb-3">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-sm-3">
                                    <h6 class="mb-0">Birthdate</h6>
                                </div>
                                <div class="col-sm-9 text-secondary">
                                    {{ user.profile.birthdate }}
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <div class="col-sm-3">
                                    <h6 class="mb-0">Phone</h6>
                                </div>
                                <div class="col-sm-9 text-secondary">
                                    {{ user.profile.phone_number}}
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <div class="col-sm-3">
                                    <h6 class="mb-0">Gender</h6>
                                </div>
                                <div class="col-sm-9 text-secondary">
                                    {{ user.profile.sex}}
                                </div>
                            </div>
                            <hr>
                            <div class="row">
                                <div class="col-sm-3">
                                    <h6 class="mb-0">Position</h6>
                                </div>
                                <div class="col-sm-9 text-secondary">
                                    {{ user.profile.user_type}}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>

{% endblock %}

src/templates/search-history.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div>
        {% for element in search_history_list %}
            <p> {{ element }}</p>
        {% endfor %}
    </div>
{% endblock %}